diff -u arc2/ac.scm arc3/ac.scm
--- arc2/ac.scm	2008-02-24 19:38:13.000000000 -0500
+++ arc3/ac.scm	2009-05-30 17:09:15.000000000 -0400
@@ -795,71 +895,82 @@
 (define char->ascii char->integer)
 (define ascii->char integer->char)
 
-(xdef 'coerce (lambda (x type . args)
-                (cond 
-                  ((ar-tagged? x) (err "Can't coerce annotated object"))
-                  ((eqv? type (ar-type x)) x)
-
-                  ((char? x)      (case type
-                                    ((int)    (char->ascii x))
-                                    ((string) (string x))
-                                    ((sym)    (string->symbol (string x)))
-                                    (else     (err "Can't coerce" x type))))
-                  ((integer? x)   (case type
-                                    ((char)   (ascii->char x))
-                                    ((string) (apply number->string x args))
-                                    (else     (err "Can't coerce" x type))))
-                  ((number? x)    (case type
-                                    ((int)    (round x))
-                                    ((char)   (ascii->char (round x)))
-                                    ((string) (apply number->string x args))
-                                    (else     (err "Can't coerce" x type))))
-                  ((string? x)    (case type
-                                    ((sym)    (string->symbol x))
-                                    ((cons)   (ac-niltree (string->list x)))
-                                    ((int)    (or (apply string->number x args)
-                                                  (err "Can't coerce" x type)))
-                                    (else     (err "Can't coerce" x type))))
-                  ((pair? x)      (case type
-                                    ((string) (list->string
-                                               (ar-nil-terminate x)))   
-                                    (else     (err "Can't coerce" x type))))
-                  ((eqv? x 'nil)  (case type
-                                    ((string) "")
-                                    (else     (err "Can't coerce" x type))))
-                  ((symbol? x)    (case type 
-                                    ((string) (symbol->string x))
-                                    (else     (err "Can't coerce" x type))))
-                  (#t             x))))
+(define (iround x) (inexact->exact (round x)))
+
+(xdef coerce 
+  (lambda (x type . args)
+    (cond 
+      ((ar-tagged? x) (err "Can't coerce annotated object"))
+      ((eqv? type (ar-type x)) x)
+
+      ((char? x)      (case type
+                        ((int)    (char->ascii x))
+                        ((string) (string x))
+                        ((sym)    (string->symbol (string x)))
+                        (else     (err "Can't coerce" x type))))
+      ((integer? x)   (case type
+                        ((char)   (ascii->char x))
+                        ((string) (apply number->string x args))
+                        (else     (err "Can't coerce" x type))))
+      ((number? x)    (case type
+                        ((int)    (iround x))
+                        ((char)   (ascii->char (iround x)))
+                        ((string) (apply number->string x args))
+                        (else     (err "Can't coerce" x type))))
+      ((string? x)    (case type
+                        ((sym)    (string->symbol x))
+                        ((cons)   (ac-niltree (string->list x)))
+                        ((int)    (let ((n (apply string->number x args)))
+                                    (if n 
+                                        (iround n)
+                                        (err "Can't coerce" x type))))
+                        (else     (err "Can't coerce" x type))))
+      ((pair? x)      (case type
+                        ((string) (list->string
+                                   (ar-nil-terminate x)))   
+                        (else     (err "Can't coerce" x type))))
+      ((eqv? x 'nil)  (case type
+                        ((string) "")
+                        (else     (err "Can't coerce" x type))))
+      ((symbol? x)    (case type 
+                        ((string) (symbol->string x))
+                        (else     (err "Can't coerce" x type))))
+      (#t             x))))
 
-(xdef 'open-socket  (lambda (num) (tcp-listen num 50 #t))) 
+(xdef open-socket  (lambda (num) (tcp-listen num 50 #t))) 
 
 ; the 2050 means http requests currently capped at 2 meg
 ; http://list.cs.brown.edu/pipermail/plt-scheme/2005-August/009414.html
 
-(xdef 'socket-accept (lambda (s)
-                       (call-with-values
+(xdef socket-accept (lambda (s)
+                      (let ((oc (current-custodian))
+                            (nc (make-custodian)))
+                        (current-custodian nc)
+                        (call-with-values
                          (lambda () (tcp-accept s))
                          (lambda (in out)
-                           (list (make-limited-input-port in 100000 #t)
-                                 out
-                                 (let-values (((us them) (tcp-addresses out)))
-                                   them))))))
-
-(xdef 'new-thread thread)
-(xdef 'kill-thread kill-thread)
-(xdef 'break-thread break-thread)
+                           (let ((in1 (make-limited-input-port in 100000 #t)))
+                             (current-custodian oc)
+                             (associate-custodian nc in1 out)
+                             (list in1
+                                   out
+                                   (let-values (((us them) (tcp-addresses out)))
+                                               them))))))))
+
+(xdef new-thread thread)
+(xdef kill-thread kill-thread)
+(xdef break-thread break-thread)
 
 (define (wrapnil f) (lambda args (apply f args) 'nil))
 
-(xdef 'sleep (wrapnil sleep))
+(xdef sleep (wrapnil sleep))
 
 ; Will system "execute" a half-finished string if thread killed
 ; in the middle of generating it?  
 
-(xdef 'system (wrapnil system))
+(xdef system (wrapnil system))
 
-(xdef 'pipe-from (lambda (cmd)
+(xdef pipe-from (lambda (cmd)
                    (let ((tf (ar-tmpname)))
                      (system (string-append cmd " > " tf))
                      (let ((str (open-input-file tf)))
@@ -884,9 +995,9 @@
 ; PLT scheme provides only eq? and equal? hash tables,
 ; we need the latter for strings.
 
-(xdef 'table (lambda () (make-hash-table 'equal)))
+(xdef table (lambda () (make-hash-table 'equal)))
 
-;(xdef 'table (lambda args
+;(xdef table (lambda args
 ;               (fill-table (make-hash-table 'equal) 
 ;                           (if (pair? args) (ac-denil (car args)) '()))))
                    
@@ -897,32 +1008,43 @@
         (begin (hash-table-put! h (car pair) (cadr pair))
                (fill-table h (cdr pairs))))))
 
-(xdef 'maptable (lambda (fn table)               ; arg is (fn (key value) ...)
+(xdef maptable (lambda (fn table)               ; arg is (fn (key value) ...)
                   (hash-table-for-each table fn)
                   table))
 
-(xdef 'protect (lambda (during after)
-                  (dynamic-wind (lambda () #t) during after)))
+(define (protect during after)
+  (dynamic-wind (lambda () #t) during after))
+
+(xdef protect protect)
 
 ; need to use a better seed
 
-(xdef 'rand random)
+(xdef rand random)
+
+(xdef dir (lambda (name)
+            (ac-niltree (map path->string (directory-list name)))))
 
-(xdef 'dir (lambda (name) (map path->string (directory-list name))))
+; Would def mkdir in terms of make-directory and call that instead
+; of system in ensure-dir, but make-directory is too weak: it doesn't
+; create intermediate directories like mkdir -p.
 
-(xdef 'file-exists (lambda (name)
+(xdef file-exists (lambda (name)
                      (if (file-exists? name) name 'nil)))
 
-(xdef 'dir-exists (lambda (name)
+(xdef dir-exists (lambda (name)
                      (if (directory-exists? name) name 'nil)))
 
-(xdef 'rmfile (wrapnil delete-file))
+(xdef rmfile (wrapnil delete-file))
+
+(xdef mvfile (lambda (old new)
+                (rename-file-or-directory old new #t)
+                'nil))
 
 ; top level read-eval-print
 ; tle kept as a way to get a break loop when a scheme err
 
 (define (arc-eval expr) 
-  (eval (ac expr '()) (interaction-environment)))
+  (eval (ac expr '())))
 
 (define (tle)
   (display "Arc> ")
@@ -990,7 +1112,7 @@
     (if (eof-object? x)
         #t
         (let ((scm (ac x '())))
-          (eval scm (interaction-environment))
+          (eval scm)
           (pretty-print scm op)
           (newline op)
           (newline op)
@@ -1008,12 +1130,12 @@
           (lambda (op)
             (acompile1 ip op)))))))
 
-(xdef 'macex (lambda (e) (ac-macex (ac-denil e))))
+(xdef macex (lambda (e) (ac-macex (ac-denil e))))
 
-(xdef 'macex1 (lambda (e) (ac-macex (ac-denil e) 'once)))
+(xdef macex1 (lambda (e) (ac-macex (ac-denil e) 'once)))
 
-(xdef 'eval (lambda (e)
-              (eval (ac (ac-denil e) '()) (interaction-environment))))
+(xdef eval (lambda (e)
+              (eval (ac (ac-denil e) '()))))
 
 ; If an err occurs in an on-err expr, no val is returned and code
 ; after it doesn't get executed.  Not quite what I had in mind.
@@ -1025,7 +1147,7 @@
          (with-handlers ((exn:fail? (lambda (c) 
                                       (k (lambda () (errfn c)))))) 
                         (f)))))))
-(xdef 'on-err on-err)
+(xdef on-err on-err)
 
 (define (disp-to-string x)
   (let ((o (open-output-string)))
@@ -1033,16 +1155,16 @@
     (close-output-port o)
     (get-output-string o)))
 
-(xdef 'details (lambda (c)
+(xdef details (lambda (c)
                  (disp-to-string (exn-message c))))
 
-(xdef 'scar (lambda (x val) 
+(xdef scar (lambda (x val) 
               (if (string? x) 
                   (string-set! x 0 val)
                   (set-car! x val))
               val))
 
-(xdef 'scdr (lambda (x val) 
+(xdef scdr (lambda (x val) 
               (if (string? x)
                   (err "Can't set cdr of a string" x)
                   (set-cdr! x val))
@@ -1059,14 +1181,17 @@
         (string-set! str i (string-ref val (- i index))))
       (err "Length mismatch between strings" str val index)))
 
-(xdef 'sref (lambda (com val ind) ; later make ind rest arg
-              (cond ((hash-table? com)  (if (eqv? val 'nil)
-                                            (hash-table-remove! com ind)
-                                            (hash-table-put! com ind val)))
-                    ((string? com) (string-set! com ind val))
-                    ((pair? com)   (nth-set! com ind val))
-                    (#t (err "Can't set reference " com ind val)))
-              val))
+; Later may want to have multiple indices.
+
+(xdef sref 
+  (lambda (com val ind)
+    (cond ((hash-table? com)  (if (eqv? val 'nil)
+                                  (hash-table-remove! com ind)
+                                  (hash-table-put! com ind val)))
+          ((string? com) (string-set! com ind val))
+          ((pair? com)   (nth-set! com ind val))
+          (#t (err "Can't set reference " com ind val)))
+    val))
 
 (define (nth-set! lst n val)
   (set-car! (list-tail lst n) val))
@@ -1078,24 +1203,24 @@
                             #t
                             (lambda () #f)))
 
-(xdef 'bound (lambda (x) (tnil (bound? x))))
+(xdef bound (lambda (x) (tnil (bound? x))))
 
-(xdef 'newstring make-string)
+(xdef newstring make-string)
 
-(xdef 'trunc (lambda (x) (inexact->exact (truncate x))))
+(xdef trunc (lambda (x) (inexact->exact (truncate x))))
 
-(xdef 'exact (lambda (x) 
+(xdef exact (lambda (x) 
                (tnil (and (integer? x) (exact? x)))))
 
-(xdef 'msec                         current-milliseconds)
-(xdef 'current-process-milliseconds current-process-milliseconds)
-(xdef 'current-gc-milliseconds      current-gc-milliseconds)
+(xdef msec                         current-milliseconds)
+(xdef current-process-milliseconds current-process-milliseconds)
+(xdef current-gc-milliseconds      current-gc-milliseconds)
 
-(xdef 'seconds current-seconds)
+(xdef seconds current-seconds)
 
 (print-hash-table #t)
 
-(xdef 'client-ip (lambda (port) 
+(xdef client-ip (lambda (port) 
                    (let-values (((x y) (tcp-addresses port)))
                      y)))
 
@@ -1103,40 +1228,112 @@
 ; inside an atomic-invoke. atomic-invoke is allowed to
 ; nest within a thread; the thread-cell keeps track of
 ; whether this thread already holds the lock.
-; XXX make sure cell is set #f after an exception?
-; maybe it doesn't matter since thread will die?
 
 (define ar-the-sema (make-semaphore 1))
 
 (define ar-sema-cell (make-thread-cell #f))
 
-(xdef 'atomic-invoke (lambda (f)
+(xdef atomic-invoke (lambda (f)
                        (if (thread-cell-ref ar-sema-cell)
                            (ar-apply f '())
                            (begin
                              (thread-cell-set! ar-sema-cell #t)
-                             (let ((ret 
-                                    (call-with-semaphore
-                                     ar-the-sema
-                                     (lambda () (ar-apply f '())))))
-                               (thread-cell-set! ar-sema-cell #f)
-                               ret)))))
+			     (protect
+			      (lambda ()
+				(call-with-semaphore
+				 ar-the-sema
+				 (lambda () (ar-apply f '()))))
+			      (lambda ()
+				(thread-cell-set! ar-sema-cell #f)))))))
 
-(xdef 'dead (lambda (x) (tnil (thread-dead? x))))
+(xdef dead (lambda (x) (tnil (thread-dead? x))))
 
-; Added because Mzscheme buffers output.  Not sure if want as official
-; part of Arc.
+; Added because Mzscheme buffers output.  Not a permanent part of Arc.
+; Only need to use when declare explicit-flush optimization.
 
-;(xdef 'flushout (lambda () (flush-output) 't))
+(xdef flushout (lambda () (flush-output) 't))
 
-(xdef 'ssyntax (lambda (x) (tnil (ssyntax? x))))
+(xdef ssyntax (lambda (x) (tnil (ssyntax? x))))
 
-(xdef 'ssexpand (lambda (x)
+(xdef ssexpand (lambda (x)
                   (if (symbol? x) (expand-ssyntax x) x)))
 
-(xdef 'quit exit)
+(xdef quit exit)
 
+; there are two ways to close a TCP output port.
+; (close o) waits for output to drain, then closes UNIX descriptor.
+; (force-close o) discards buffered output, then closes UNIX desc.
+; web servers need the latter to get rid of connections to
+; clients that are not reading data.
+; mzscheme close-output-port doesn't work (just raises an error)
+; if there is buffered output for a non-responsive socket.
+; must use custodian-shutdown-all instead.
+
+(define custodians (make-hash-table 'equal))
+
+(define (associate-custodian c i o)
+  (hash-table-put! custodians i c)
+  (hash-table-put! custodians o c))
+
+; if a port has a custodian, use it to close the port forcefully.
+; also get rid of the reference to the custodian.
+; sadly doing this to the input port also kills the output port.
+
+(define (try-custodian p)
+  (let ((c (hash-table-get custodians p #f)))
+    (if c
+        (begin
+          (custodian-shutdown-all c)
+          (hash-table-remove! custodians p)
+          #t)
+        #f)))
+
+(define (ar-close . args)
+  (map (lambda (p)
+         (cond ((input-port? p)   (close-input-port p))
+               ((output-port? p)  (close-output-port p))
+               ((tcp-listener? p) (tcp-close p))
+               (#t (err "Can't close " p))))
+       args)
+  (map (lambda (p) (try-custodian p)) args) ; free any custodian
+  'nil)
+
+(xdef close ar-close)
+
+(xdef force-close (lambda args
+                       (map (lambda (p)
+                              (if (not (try-custodian p))
+                                  (ar-close p)))
+                            args)
+                       'nil))
+
+(xdef memory current-memory-use)
+
+(xdef declare (lambda (key val)
+                (case key
+                  ((direct-calls) 
+                   (set! direct-calls (not (eq? val 'nil))))
+                  ((explicit-flush) 
+                   (set! explicit-flush (not (eq? val 'nil)))))))
+
+(putenv "TZ" ":GMT")
+
+(define (gmt-date sec) (seconds->date sec))
+
+(xdef timedate 
+  (lambda args
+    (let ((d (gmt-date (if (pair? args) (car args) (current-seconds)))))
+      (ac-niltree (list (date-second d)
+                        (date-minute d)
+                        (date-hour d)
+                        (date-day d)
+                        (date-month d)
+                        (date-year d))))))
+
+(xdef sin sin)
+(xdef cos cos)
+(xdef tan tan)
+(xdef log log)
 
 )
 
-(require ac)
